-- name: [CS] Parappa the Rapper
-- description: Ya gotta believe!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_PARAPPA = smlua_model_util_get_id("parappa_geo")

local TEX_PARAPPA_ICON = get_texture_info("parappa-icon")

local TEXT_MOD_NAME = "Parappa the Rapper"

local VOICETABLE_PARAPPA = {
    [CHAR_SOUND_ATTACKED] = 'parappa-oops.ogg',
    [CHAR_SOUND_DOH] = 'parappa-oops.ogg',
    [CHAR_SOUND_DROWNING] = nil,
    [CHAR_SOUND_DYING] = nil,
    [CHAR_SOUND_GROUND_POUND_WAH] = 'parappa-yeah.ogg',
    [CHAR_SOUND_HAHA] = 'parappa-yeah.ogg',
    [CHAR_SOUND_HAHA_2] = 'parappa-yo.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'parappa-believe.ogg',
    [CHAR_SOUND_HOOHOO] = 'parappa-yo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'parappa-oops.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'parappa-yeah.ogg',
    [CHAR_SOUND_ON_FIRE] = 'parappa-oops.ogg',
    [CHAR_SOUND_OOOF] = 'parappa-oops.ogg',
    [CHAR_SOUND_OOOF2] = 'parappa-oops.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'parappa-kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'parappa-punch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'parappa-punch2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'parappa-yeah.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'parappa-yeah.ogg',
    [CHAR_SOUND_WAAAOOOW] = nil,
    [CHAR_SOUND_WAH2] = 'parappa-kick.ogg',
    [CHAR_SOUND_WHOA] = 'parappa-oops.ogg',
    [CHAR_SOUND_YAHOO] = 'parappa-ho.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'parappa-believe.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'parappa-jump.ogg',
    [CHAR_SOUND_YAWNING] = nil,
}

local PALETTE_PARAPPA = {
    [PANTS]  = "0F2B6C",
    [SHIRT]  = "5E98E4",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "DE2919",
    [HAIR]   = "000000",
    [SKIN]   = "FEFDCC",
    [CAP]    = "F47412",
}

--[[ PaRappa does NOT take his hat off under ANY circumstances, as canonically, hatless PaRappa is a horrid sight.
local CAPTABLE_PARAPPA = {
    normal = smlua_model_util_get_id("parappa_cap_normal_geo"),
    wing = smlua_model_util_get_id("parappa_cap_wing_geo"),
    metal = smlua_model_util_get_id("parappa_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("parappa_cap_wing_geo"),
}
--]]
if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("Parappa the Rapper", "A young pup that loves rapping and overall having fun. He would do anything for the love of his life, Sunny Funny.", "MlopsFunny", {r = 244, g = 115, b = 20}, E_MODEL_PARAPPA, CT_MARIO, TEX_PARAPPA_ICON)
--      _G.charSelect.character_add_caps(E_MODEL_PARAPPA, CAPTABLE_PARAPPA)

    _G.charSelect.character_add_palette_preset(E_MODEL_PARAPPA, PALETTE_PARAPPA)

     --the following must be hooked for each character added

    _G.charSelect.character_add_voice(E_MODEL_PARAPPA, VOICETABLE_PARAPPA)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_PARAPPA then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_PARAPPA then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end